const EMAILVAL_ACTION = 'emailval_form';

jQuery(document).ready(function() {

    var form = jQuery('#emailval-form');
    form.find('.response-group #closeButton').click(function() {
        jQuery(this).parent().css('display', 'none');
    });

    form.find('#email').on('input', function() {
        var value = jQuery(this).val();
        jQuery(this).val(value.replace(/\s/g, ''));
    });

    form.on("submit", function(e) {

        var formData = {};
        formData['action'] = EMAILVAL_ACTION;
        jQuery.each(jQuery(this).serializeArray(), function() {
            formData[this.name] = this.value;
        });

        var jqxhr = jQuery.post({
            url: EMAILVAL_DATA.ajaxUrl,
            data: formData,
            error: function(jqxhr, textStatus, error) {
                var responseGroup = jQuery('#emailval-form .response-group');
                responseGroup.find('#message').text('Server error');
                responseGroup.css('display', 'felx')
                    .addClass('failure-response')
                    .removeClass('valid-response')
                    .removeClass('invalid-response');
            },
            success: function(data, textStatus, jqxhr) {
                var status = data['data']['status'];
                var result = data['data']['result'];

                var responseGroup = jQuery('#emailval-form .response-group');
                responseGroup.find('#message').text(result);
                if (result.toLowerCase().includes('valid-response')) {
                    responseGroup.css('display', 'flex')
                        .removeClass('valid-response')
                        .addClass('invalid-response');
                } else {
                    responseGroup.css('display', 'flex')
                        .removeClass('invalid-response')
                        .addClass('valid-response');
                }
            }
        });

        jqxhr.always(function() {
            jQuery('#emailval-form .submit-group button').prop('disabled', false);
        });

        e.preventDefault();
        jQuery(this).find('.submit-group button').prop('disabled', true);
    });
});